第十章 单调栈

一、每日温度

Leetcode 739

class Solution {
public:
    vector<int> dailyTemperatures(vector<int>& temperatures) {
        stack<int> stk; // 存放元素下标
        vector<int> res(temperatures.size(), 0);
        for (int i = 0; i < temperatures.size(); i ++ ) {
            while (!stk.empty() && temperatures[i] > temperatures[stk.top()]) 
                res[stk.top()] = i - stk.top(), stk.pop();
            stk.push(i);
        }
        return res;
    }
};

二、下一个更大元素 Ⅰ

Leetcode 496

class Solution {
public:
    vector<int> nextGreaterElement(vector<int>& nums1, vector<int>& nums2) {
        stack<int> stk;
        vector<int> res(nums1.size(), -1);
        unordered_map<int, int> mp;
        for (int i = 0; i < nums1.size(); i ++ ) mp[nums1[i]] = i;
        stk.push(0);
        for (int i = 1; i < nums2.size(); i ++ ) {
            while (!stk.empty() && nums2[i] > nums2[stk.top()]) {
                if (mp.count(nums2[stk.top()]) > 0)
                    res[mp[nums2[stk.top()]]] = nums2[i];
                stk.pop();
            }
            stk.push(i);
        }
        return res;
    }
};

三、下一个更大元素 Ⅱ

Leetcode 503

思路一:将数组复制一遍

class Solution {
public:
    vector<int> nextGreaterElements(vector<int>& nums) {
        vector<int> nums1(nums.begin(), nums.end());
        nums.insert(nums.end(), nums1.begin(), nums1.end());
        vector<int> res(nums.size(), -1);
        if (!nums.size()) return res;
        stack<int> stk;
        stk.push(0);
        for (int i = 1; i < nums.size(); i ++ ) {
            while (!stk.empty() && nums[i] > nums[stk.top()]) {
                res[stk.top()] = nums[i];
                stk.pop();
            }
            stk.push(i);
        }
        res.resize(nums.size() / 2);
        return res;
    }
};

思路二:不复制数组,直接遍历两边数组

class Solution {
public:
    vector<int> nextGreaterElements(vector<int>& nums) {
        vector<int> res(nums.size(), -1);
        if (!nums.size()) return res;
        stack<int> stk;
        for (int i = 0; i < nums.size() * 2; i ++ ) {
            while (!stk.empty() && nums[i % nums.size()] > nums[stk.top()]) {
                res[stk.top()] = nums[i % nums.size()];
                stk.pop();
            }
            stk.push(i % nums.size());
        }
        return res;
    }
};

四、接雨水

Leetcode 42

当前列雨水面积:min(左边柱子的最高高度,记录右边柱子的最高高度) - 当前柱子高度。要注意第一个柱子和最后一个柱子不接雨水。

思路一:双指针

class Solution {
public:
    int trap(vector<int>& height) {
        if (height.size() <= 2) return 0;
        // 分别记录当前列左边最大值与右边最大值
        vector<int> maxL(height.size(), 0), maxR(height.size(), 0);
        int n = height.size();

        // 记录每个柱子的左边最大值 = max(上一个柱子左边最大值,当前柱子高度)
        maxL[0] = height[0];
        for (int i = 1; i < n; i ++ )
            maxL[i] = max(maxL[i - 1], height[i]);

        // 记录每个柱子的右边最大值 = max(上一个柱子右边最大值,当前柱子高度)
        maxR[n - 1] = height[n - 1];
        for (int i = n - 2; i >= 0; i -- )
            maxR[i] = max(maxR[i + 1], height[i]);
        
        int res = 0;
        for (int i = 0; i < n; i ++ ) {
            int count = min(maxL[i], maxR[i]) - height[i];
            if (count > 0) res += count;
        }

        return res;
    }
};

思路二:单调栈

单调栈:求一个元素右边第一个更大元素,单调栈就是递增的;求一个元素右边第一个更小元素,单调栈就是递减的。

从栈头(元素从栈头弹出)到栈底的顺序应该是从小到大的顺序。因为一旦发现添加的柱子高度大于栈头元素了,此时就出现凹槽了,栈头元素就是凹槽底部的柱子,栈头第二个元素就是凹槽左边的柱子,而添加的元素就是凹槽右边的柱子。

遇到相同的元素,更新栈内下标,就是将栈里元素(旧下标)弹出,将新元素(新下标)加入栈中。

class Solution {
public:
    int trap(vector<int>& height) {
        stack<int> stk; stk.push(0);
        int res = 0;
        for (int i = 1; i < height.size(); i ++ ) {
            while (!stk.empty() && height[i] > height[stk.top()]) {
                int mid = stk.top(); stk.pop();
                if (!stk.empty()) {
                    int h = min(height[stk.top()], height[i]) - height[mid];
                    int w = i - stk.top() - 1;
                    res += h * w;
                }
            }
            stk.push(i);
        }
        return res;
    }
};

五、柱状图中最大的矩形

Leetcode 84

思路一:双指针

class Solution {
public:
    int largestRectangleArea(vector<int>& heights) {
        vector<int> minL(heights.size()), minR(heights.size());
        int n = heights.size();

        // 记录每个柱子左边第一个小于该柱子的下标
        minL[0] = -1; // 防止下面while死循环
        for (int i = 1; i < n; i ++ ) {
            int t = i - 1;
            while (t >= 0 && heights[t] >= heights[i]) t = minL[t];
            minL[i] = t;
        }

        // 记录每个柱子右边第一个小于该柱子的下标 
        minR[n - 1] = n; // 防止下面while死循环
        for (int i = n - 2; i >= 0; i -- ) {
            int t = i + 1;
            while (t  < n && heights[t] >= heights[i]) t = minR[t];
            minR[i] = t;
        }

        int res = 0;
        for (int i = 0; i < n; i ++ ) {
            int sum = heights[i] * (minR[i] - minL[i] - 1);
            res = max(sum, res);
        }
        return res;
    }
};

思路二:单调栈

class Solution {
public:
    int largestRectangleArea(vector<int>& heights) {
        stack<int> stk; stk.push(0);
        // 注意是找左右两边比当前柱子高度小的元素,不加0可能找不到
        heights.insert(heights.begin(), 0);
        heights.push_back(0);
        int res = 0;
        for (int i = 1; i < heights.size(); i ++ ) {
            while (!stk.empty() && heights[i] < heights[stk.top()]) {
                int mid = stk.top(); stk.pop();
                if (!stk.empty()) {
                    int w = i - stk.top() - 1;
                    int h = heights[mid];
                    res = max(res, w * h);
                }
            }
            stk.push(i);
        }
        return res;
    }
};
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值